commit ce5238daddbc78fd593130c356aea8a9cb7c575e
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Mon Dec 7 10:48:06 2020 +0100

    Fix internal error on library-level type extended locally
    
    The compiler aborts on the local extension of a tagged type declared
    at library level, with a progenitor given by an interface type having
    a primitive that is a homograph of a primitive of the tagged type.
    
    gcc/ada/ChangeLog:
            * gcc-interface/trans.c (maybe_make_gnu_thunk): Return false if the
            target is local and thunk and target do not have the same context.

diff --git a/gcc/ada/gcc-interface/trans.c b/gcc/ada/gcc-interface/trans.c
index 6f316e0ec11..934db8894f2 100644
--- a/gcc/ada/gcc-interface/trans.c
+++ b/gcc/ada/gcc-interface/trans.c
@@ -11306,8 +11306,11 @@ maybe_make_gnu_thunk (Entity_Id gnat_thunk, tree gnu_thunk)
 
   tree gnu_target = gnat_to_gnu_entity (gnat_target, NULL_TREE, false);
 
-  /* Thunk and target must have the same nesting level, if any.  */
-  gcc_assert (DECL_CONTEXT (gnu_thunk) == DECL_CONTEXT (gnu_target));
+  /* If the target is local, then thunk and target must have the same context
+     because cgraph_node::expand_thunk can only forward the static chain.  */
+  if (DECL_STATIC_CHAIN (gnu_target)
+      && DECL_CONTEXT (gnu_thunk) != DECL_CONTEXT (gnu_target))
+    return false;
 
   /* If the target returns by invisible reference and is external, apply the
      same transformation as Subprogram_Body_to_gnu here.  */

